=== debian/changelog ===
clam-networkeditor (1.4.0-3.1build1) wily; urgency=medium

  * No-change rebuild using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 20:03:33 +0200

clam-networkeditor (1.4.0-3.1) unstable; urgency=low

  * NMU
  * Build with qt 4.8. Closes: #660252. Thanks to Andreas Moog for the
    patch.
  * Add -fpermissive to g++ command line to allow building with gcc 4.7
    Closes: #667137

 -- Steve McIntyre <93sam@debian.org>  Sun, 13 May 2012 15:46:02 +0100

clam-networkeditor (1.4.0-3) unstable; urgency=low

  * debian/control: remove dev packages which are depended by libclam-dev.
    (Closes: #626919)
  * Bump Standards-Version to 3.9.2 (with no changes).

 -- TANIGUCHI Takaki <takaki@debian.org>  Mon, 16 May 2011 20:26:06 +0900

clam-networkeditor (1.4.0-2) unstable; urgency=low

  * debian/control: add scons to Build-Depends. (Closes: #620286) 
    And many packages.
  * debian/patches/FTBFS_with_gcc4.5: Added. 

 -- TANIGUCHI Takaki <takaki@debian.org>  Tue, 05 Apr 2011 18:09:00 +0900

clam-networkeditor (1.4.0-1) unstable; urgency=low

  * Initial release (Closes: #517882)

 -- TANIGUCHI Takaki <takaki@debian.org>  Fri, 28 Jan 2011 16:07:12 +0900
