=== debian/control ===
Source: clam-networkeditor
Section: sound
Priority: extra
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: TANIGUCHI Takaki <takaki@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
	libclam-dev,
	libqt4-dev,
	libqtwebkit-dev,
	libqt4-opengl-dev,
	ladspa-sdk,
	scons
Standards-Version: 3.9.2
Homepage: http://clam-project.org/
#Vcs-Git: git://git.debian.org/collab-maint/clam-networkeditor.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/clam-networkeditor.git;a=summary

Package: clam-networkeditor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: qt4-designer, faust 
Description: CLAM Network Editor, prototyping tool for CLAM
 The CLAM Network Editor is a tool for editing CLAM processing networks.
 Those processing networks can become the processing core of an audio
 application by using the CLAM::NetworkPlayer class in such program, 
 or by using the CLAM Prototyper to link the network to a Qt Designer
 interface.
 .
 This package provides both the Network Editor and the Prototyper.
 It also provides a plugin for Qt Designer which adds widgets
 to display several kinds of CLAM audio objects from a running network.

Package: clam-networkeditor-examples
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, 
	clam-networkeditor (>= ${source:Version} ), 
Description: CLAM Network Editor, examples
 The CLAM Network Editor is a tool for editing CLAM processing networks.
 Those processing networks can become the processing core of an audio
 application by using the CLAM::NetworkPlayer class in such program, 
 or by using the CLAM Prototyper to link the network to a Qt Designer
 interface.
 .
 This package provides examples of networks, some of them with 
 their user interface to be executed also by the Prototyper.
 Those examples include, among others, some sinusoidal plus residual 
 modelling (SMS) transformations and tonal (chords, notes) analysis.

Package: libclam-qtmonitors1.4
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libclam-qtmonitors CLAM extensions shared library
 The CLAM framework can be used to develop rich real-time audio and music
 applications either by c++ programming or by visual means using the
 CLAM NetworkEditor.
 .
 This package provides the shared libraries and the plugins for the
 for adding graphical processing units to your CLAM applications.
 Real-time data visualization, control sending...

Package: libclam-qtmonitors-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, 
	libclam-qtmonitors1.4 (= ${binary:Version}),
	libclam-dev
Description: development files for libclam-qtmonitors CLAM extensions
 The CLAM framework can be used to develop rich real-time audio and music
 applications either by c++ programming or by visual means using the
 CLAM NetworkEditor.
 .
 This package provides the files to develop using modules provided by
 the clam-qtmonitors CLAM plugin.
