=== debian/watch ===
version=3
http://clam-project.org/download/src/ NetworkEditor-(.*)\.tar\.gz
